SystemOrganization addCategory: #TusLibros!

Bag subclass: #Carrito
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

Object subclass: #TusLibrosBook
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!TusLibrosBook methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 5/29/2013 17:39'!
value: aTusLibrosBook 
	^true.! !

TestCase subclass: #EditorialTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!EditorialTest methodsFor: 'carritoIntansce' stamp: 'SebastianGarbi 5/27/2013 21:09'!
carrito
	^Carrito new.! !

!EditorialTest methodsFor: 'libroinstances' stamp: 'SebastianGarbi 5/29/2013 17:18'!
libro
	^TusLibrosBook new.! !

!EditorialTest methodsFor: 'libroinstances' stamp: 'SebastianGarbi 5/29/2013 17:55'!
otroLibro
	^TusLibrosBook new.! !

!EditorialTest methodsFor: '01- Carrito' stamp: 'SebastianGarbi 5/27/2013 21:09'!
test01CarritoShouldBeEmptyAfterCreation
	self assert: (self carrito isEmpty). ! !

!EditorialTest methodsFor: '01- Carrito' stamp: 'SebastianGarbi 5/29/2013 17:52'!
test02CarritoMustHaveABookAfterAdding
	|unCarrito unLibro unNumero|
	unCarrito := self carrito.
	unLibro := self libro.
	unNumero := 1.
	unCarrito add: unLibro withOccurrences:  unNumero. 
	self deny:  (unCarrito ) isEmpty. 
	self assert:  (unCarrito contains: unLibro). 
	self assert:  ((unCarrito occurrencesOf: unLibro) = unNumero).! !

!EditorialTest methodsFor: '01- Carrito' stamp: 'SebastianGarbi 5/29/2013 17:54'!
test03CanIncreaseBookQuantity
	|unCarrito unLibro unNumero|
	unCarrito := self carrito.
	unLibro := self libro.
	unNumero := 1.
	unCarrito add: unLibro withOccurrences: unNumero  .
	unCarrito add: unLibro withOccurrences: unNumero  .
	 
	self assert:  ((unCarrito occurrencesOf: unLibro) = (unNumero * 2)).! !

!EditorialTest methodsFor: '01- Carrito' stamp: 'SebastianGarbi 5/29/2013 17:56'!
test04CanAddDifferentBooks
	|unCarrito unLibro otroLibro unNumero|
	unCarrito := self carrito.
	unLibro := self libro.
	otroLibro := self otroLibro.
	unNumero := 1.
	
	unCarrito add: unLibro withOccurrences: unNumero  .
	unCarrito add: otroLibro withOccurrences: unNumero  .
	 
	self assert: (unCarrito contains: unLibro).
	self assert: (unCarrito contains: otroLibro).! !

!EditorialTest methodsFor: '01- Carrito' stamp: 'SebastianGarbi 5/29/2013 17:59'!
test05AddingDifferentBooksRespectQuantities
	|unCarrito unLibro otroLibro unNumero otroNumero|
	unCarrito := self carrito.
	unLibro := self libro.
	otroLibro := self otroLibro.
	unNumero := 5.
	otroNumero := 4.
	
	unCarrito add: unLibro withOccurrences: unNumero .
	unCarrito add: otroLibro withOccurrences: otroNumero .
	
	
	 
	self assert: (unCarrito occurrencesOf: unLibro ) = unNumero .
	self assert: (unCarrito occurrencesOf: otroLibro) = otroNumero .! !
